Subject: bug#29423: 27.0.50; ls-lisp does not handle -F switch properly

From: Drew Adams <[email-masked]>
Date: Fri, 24 Nov 2017 09:12:11 -0800 (PST)

> > I think you're talking (only) about the final / char.
> > That seems to be the only place where the property is not
> > present.
> 
> Yes. Finally, it was triggered by Tramp using the F switch. This was
> added by Tramp in order to get a trailing / for directory names in the
> directory listing.

You said "Yes", but below you seem to say "No".  Is the
/ the only place where the property is not present?

> > Is that / part of the (directory as) file name?  Dunno
> > whether that consideration helps here - probably not.
> > What to cover by the property really depends on what the
> > property is used for.
> 
> No, it is not part of the file name. Like the trailing " -> foo" for
> symlinks.
> 
> My problem is, that the whole file name is missing the text property,
> not only the trailing slash.

(See above for (my) confusion about this.)

That's not what I see, in any Emacs release or in the
26.1 prerelease (MS Windows binary).  Perhaps what you
see is a problem introduced after that prerelease or
is platform-dependent?

> > Unfortunately perhaps, unlike the case for functions and
> > variables, there is no doc string for text properties.
> > Unless something is called out for this in some doc string
> > or in code comments, only the current uses of the property
> > can guide what it should apply to.
> 
> I agree. However, in the given case, the text property 'dired-filename
> shall highlight exactly the file name. It is used later in dired (as the
> name of the property says), but it is also used in Tramp, because for
> some of the Tramp backends, ls-lisp-insert-directory is used internally,
> and Tramp needs some massage on the result.

I definitely agree that the name of the directory
(sans /) needs the property.  If that's missing
then there is likely a regression.

> Parsing the output of any insert-directory is a pain. Therefore, it is
> helpful to know that the file name part of this output is marked with
> 'dired-filename.

I agree 100% that the name needs the property.
As the only char I see missing the property is the
final /, I thought that's what you were asking about
and reporting as a problem.